import { FingerParamsObjType, FingerObjType } from '../types';
export declare const BrowserInfoFun: () => Promise<{
    os: string;
    version: string;
    appCodeName: string;
    vendor: string;
    screenHeight: number;
    screenWidth: number;
    colorDepth: any;
    product: string;
    language: string;
    onLine: true;
    mimeTypes: string;
    mimeTypesLength: number;
    productSub: string;
    cookie: boolean;
    pluginsLength: number;
    plugins: string;
    userAgent: string;
    type: string;
}>;
/**
 * 浏览器MIME支持类型列表
 * @returns
 */
export declare function getBrowserMimeTypes(): string;
/**
 * 浏览器的MIME类型数量
 * @returns
 */
export declare function getBrowserMimeTypesLength(): number;
/**
 * 浏览器是否开启cookie
 * @returns
 */
export declare function getBrowserCookieEnabled(): boolean;
/**
 * 浏览器是否连接到网络
 * @returns
 */
export declare function getBrowserOnline(): true;
/**
 * 浏览器产品其他信息
 * @returns
 */
export declare function getBrowserVendor(): string;
export type pluginsObjType = () => Promise<{
    pluginList: string;
    pluginCount: number;
}>;
/**
 * 浏览器产品其他信息
 * @returns
 */
export declare const getInstalledPlugins: pluginsObjType;
/**
 * 浏览器产品名称
 * @returns
 */
export declare function getBrowserProduct(): string;
/**
 * 浏览器产品其他信息
 * @returns
 */
export declare function getBrowserProductSub(): "20030107" | "20000101" | "0";
export declare function getBrowserMimeTypeCount(): number;
export declare function getMimeTypeCount(): number;
/**
 * 显示器宽度
 * @returns
 */
export declare function getScreenColorDepth(): any;
/**
 * 显示器宽度
 * @returns
 */
export declare function getScreenWidth(): number;
/**
 * 显示器高度
 * @returns
 */
export declare function getScreenHeight(): number;
/**
 * 客户端系统
 * @returns
 */
export declare function getUserOsInfo(): "Windows 10" | "Windows 8" | "Windows 7" | "Windows Vista" | "Windows XP" | "Windows 2000" | "Mac OS" | "UNIX" | "Linux" | "Other";
/**
 * 设备系统版本
 * @returns
 */
export declare function getBrowserVersion(): string;
/**
 * 浏览器代码名称
 * @returns
 */
export declare function getAppCodeName(): string;
export declare const handleFingerprint: (localDeviceFingersObj: FingerParamsObjType) => FingerObjType;
export declare const getBrowserInfo: () => any;
export declare const getWebGLValues: () => "" | {
    renderer: any;
    vendor: any;
    version: any;
    shadingLanguageVersion: any;
    maxVertexAttributes: any;
    maxTextureSize: any;
};
