import { ManagementClient } from '../../management/ManagementClient';
import { Request, Response, NextFunction } from 'express';
export declare const loginRequired: (authingClient: ManagementClient, options: {
    /** 获取 Authing token 的 cookie key */
    cookieKey?: string;
    /** 获取 Authing token 的 query key */
    queryKey?: string;
    /** 未登录状态下的跳转链接 */
    redirectUrlOnFailure?: string;
    /** 未登录状态下的 http 状态码 */
    statusCodeOnFailure?: number;
    /** 未登录状态下的 http response body */
    responseBodyOnFailure?: any;
    /** 是否获取用户完整信息 */
    fetchUserDetail?: boolean;
}) => (req: Request, res: Response, next: NextFunction) => Promise<void | Response<any, Record<string, any>>>;
export declare const checkPermission: (authingClient: ManagementClient, resource: string, action: string, options: {
    /** 获取 Authing token 的 cookie key */
    cookieKey?: string;
    /** 获取 Authing token 的 query key */
    queryKey?: string;
    /** 未登录状态下的跳转链接 */
    redirectUrlOnFailure?: string;
    /** 未登录状态下的 http 状态码 */
    statusCodeOnFailure?: number;
    /** 未登录状态下的 http response body */
    responseBodyOnFailure?: any;
    /** 是否获取用户完整信息 */
    fetchUserDetail?: boolean;
}) => (req: Request, res: Response, next: NextFunction) => Promise<void | Response<any, Record<string, any>>>;
